//
//  AccountMO.swift
//  Tusker
//
//  Created by Shadowfacts on 4/11/20.
//  Copyright © 2020 Shadowfacts. All rights reserved.
//
//

import Foundation
import CoreData
import Pachyderm

@objc(AccountMO)
public class AccountMO: NSManagedObject {

    @nonobjc public class func fetchRequest() -> NSFetchRequest<AccountMO> {
        return NSFetchRequest<AccountMO>(entityName: "Account")
    }
    
    @NSManaged public var acct: String?
    @NSManaged public var avatar: URL?
    @NSManaged public var bot: Bool
    @NSManaged public var createdAt: Date?
    @NSManaged public var displayName: String?
    @NSManaged public var emojisData: Data?
    @NSManaged public var fieldsData: Data?
    @NSManaged public var followersCount: Int64
    @NSManaged public var followingCount: Int64
    @NSManaged public var header: URL?
    @NSManaged public var id: String?
    @NSManaged public var locked: Bool
    @NSManaged public var moved: Bool
    @NSManaged public var note: String?
    @NSManaged public var statusesCount: Int64
    @NSManaged public var url: URL?
    @NSManaged public var username: String?
    @NSManaged public var movedTo: AccountMO?
    
    @LazilyDecoding(arrayFrom: \AccountMO.emojisData)
    var emojis: [Emoji]
    
    @LazilyDecoding(arrayFrom: \AccountMO.fieldsData)
    var fields: [Account.Field]
    
}
