//
//  StatusMO.swift
//  Tusker
//
//  Created by Shadowfacts on 4/11/20.
//  Copyright © 2020 Shadowfacts. All rights reserved.
//
//

import Foundation
import CoreData
import Pachyderm

@objc(StatusMO)
public final class StatusMO: NSManagedObject {

    @nonobjc public class func fetchRequest() -> NSFetchRequest<StatusMO> {
        return NSFetchRequest<StatusMO>(entityName: "Status")
    }
    
    @NSManaged public var application: String?
    @NSManaged public var attachmentsData: Data?
    @NSManaged public var bookmarked: Bool
    @NSManaged public var content: String
    @NSManaged public var createdAt: Date
    @NSManaged public var emojisData: Data?
    @NSManaged public var favourited: Bool
    @NSManaged public var favouritesCount: Int
    @NSManaged public var hashtagsData: Data?
    @NSManaged public var id: String
    @NSManaged public var mentionsData: Data?
    @NSManaged public var muted: Bool
    @NSManaged public var pinned: Bool
    @NSManaged public var reblogged: Bool
    @NSManaged public var reblogsCount: Int
    @NSManaged public var sensitive: Bool
    @NSManaged public var uri: String
    @NSManaged public var url: URL?
    @NSManaged public var visibility: String?
    @NSManaged public var account: AccountMO
    @NSManaged public var inReplyTo: StatusMO?
    @NSManaged public var inReplyToAccount: AccountMO?
    @NSManaged public var reblog: StatusMO?
    
    @LazilyDecoding(arrayFrom: \StatusMO.attachmentsData)
    var attachments: [Attachment]

    @LazilyDecoding(arrayFrom: \StatusMO.emojisData)
    var emoji: [Emoji]
    
    @LazilyDecoding(arrayFrom: \StatusMO.hashtagsData)
    var hashtags: [Hashtag]
    
    @LazilyDecoding(arrayFrom: \StatusMO.mentionsData)
    var mentions: [Mention]
    
}
